<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER.tsx.ftl
</#ibizinclude>

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getData(): any {
        return {};
    }


    /**
     * 选中数据
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public selection: any = {};


    /**
     * 过滤值
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public srfnodefilter: string = '';

    /**
     * 是否加载默认关联视图
     *
     * @private
     * @type {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    private istLoadDefaultRefView: boolean = false;

    /**
     * 分割宽度
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public split: string = '<#if ctrl.getWidth() gt 0>${ctrl.getWidth()?c}<#else>200</#if>px';

    /**
     * 获取关系项视图
     *
     * @param {*} [arg={}]
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public getExpItemView(arg: any = {}): any {
        let expmode = arg.nodetype.toUpperCase();
        if (!expmode) {
            expmode = '';
        }
        <#list ctrl.getPSAppViewRefs() as item>
        <#if (item.getName()?index_of("EXPITEM:")==0)>
        <#assign refview = item.getRefPSAppView()>
        if (Object.is(expmode, '${item.getName()?substring(8)?upper_case}')) {
            return {  
                viewname: '${srffilepath2(refview.codeName)}', 
                parentdata: <#if item.getParentDataJO()??>${item.getParentDataJO()}<#else>{},</#if>
			};
        }
        </#if>
        </#list>
        return null;
    }

    /**
     * 树导航选中
     *
     * @param {any []} args
     * @param {string} [tag]
     * @param {*} [$event2]
     * @returns {void}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ${ctrl.name}_selectionchange(args: any [], tag?: string, $event2?: any): void {
        if (args.length === 0) {
            return ;
        }
        const arg:any = args[0];
        if (!arg.id) {
            return;
        }
        const parentdata: any = { srfparentkey: arg.srfkey };
        arg.id.split(';').forEach((value: string, index: number) => {
            if (index > 0) {
                const key = index + 1 === 1 ? 'srfparentkey' : 'srfparentkey' + (index + 1);
                Object.assign(parentdata, { [key]: value })
            }
        });
        const nodetype = arg.id.split(';')[0];
        const refview = this.getExpItemView({ nodetype: nodetype });
        if (!refview) {
            return;
        }
        Object.assign(parentdata, refview.parentdata);
        this.selection = {};
        Object.assign(this.selection, { view: { viewname: refview.viewname }, data: parentdata });
    }

    /**
     * 树加载完成
     *
     * @param {any[]} args
     * @param {string} [tag]
     * @param {*} [$event2]
     * @returns {void}
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public ${ctrl.name}_load(args: any[], tag?: string, $event2?: any): void {
    }

    /**
     * 执行搜索
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onSearch(): void {
        <#if ctrl.getPSDETree()??>
        <#assign tree = ctrl.getPSDETree()/>
        this.istLoadDefaultRefView = false;
        this.viewState.next({ tag: '${tree.name}', action: 'filter', data: { srfnodefilter: this.srfnodefilter } });
        </#if>
    }

    /**
     * vue 声明周期
     *
     * @memberof @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public created() {
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                <#if ctrl.getPSDETree()??>
                <#assign tree = ctrl.getPSDETree()/>
                this.istLoadDefaultRefView = false;
                this.viewState.next({ tag: '${tree.name}', action: action, data: data });
                </#if>
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public destroyed() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

    /**
     * 视图数据变化
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onViewDatasChange($event: any): void {
        this.$emit('selectionchange', $event);
    }

    /**
     * 视图数据被激活
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public viewDatasActivated($event: any): void {
        this.$emit('activated', $event);
    }

    /**
     * 视图数据加载完成
     *
     * @param {*} $event
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public onViewLoad($event: any): void {
        this.$emit('load', $event);
    }

    /**
     * 绘制内容
     *
     * @returns
     * @memberof ${srfclassname('${ctrl.codeName}')}
     */
    public render() {
        return (
            <split class='app-tree-exp-bar' v-model={this.split}>
                <div slot='left'>
                    <#if ctrl.isShowTitleBar()>
                    <div class='tree-exp-bar-header'>
                        <div><icon type='ios-home-outline'/><#if ctrl.getTitle() == ''>树视图导航栏<#else>${ctrl.getTitle()}</#if></div>
                    </div>
                    </#if>
                    <#if ctrl.isEnableSearch()>
                    <div class='search-content'>
                        <i-input search={true}
                            on-on-change={($event: any) => { this.srfnodefilter = $event.target.value; }}
                            on-on-search={() => this.onSearch()}></i-input>
                    </div>
                    </#if>
                    <div class='<#if ctrl.isShowTitleBar()>tree-exp-content<#else>tree-exp-content2</#if>'>
                        <#if ctrl.getPSDETree()??>
                        <#assign tree = ctrl.getPSDETree()/>
                        ${P.getCtrlCode(tree, 'CONTROL.html').code}
                        </#if>
                    </div>
                </div>
                <div slot='right'>
					{
						(this.selection.view && !Object.is(this.selection.view.viewname, '')) ?
							this.$createElement(this.selection.view.viewname, {
                                class: {
                                    viewcontainer2: true,
                                },
                                props: {
                                    viewdata: JSON.stringify({ srfparentdata: this.selection.data }),
                                },
                                on: {
                                    viewdataschange: ($event: any) => {
                                        this.onViewDatasChange($event);
                                    },
                                    viewdatasactivated: ($event: any) => {
                                        this.viewDatasActivated($event)
                                    },
                                    viewload: ($event: any) => {
                                        this.onViewLoad($event);
                                    },
                                },
							})
							: ''
					}
                </div>
            </split>
        );
    }
}
